Conceitos fundamentais
======================

# A estrutura de pastas

A forma como você organiza seu código não importará muito no funcionamento da aplicação, desde que você referencie os arquivos corretamente. Por outro lado, a forma como você organiza seu código influencia muito na leitura e entendimento da aplicação para o desenvolvedor, e por isso influencia muito na [manutenibilidade][MANUTENIBILIDADE] da mesma.

Dessa forma nós sugerimos organizar seu código da seguinte forma:

```
[root]/
  components/
  controllers/
  utils/
  index.html
  index.js
```

## A pasta "[root]"

Essa é sua pasta raiz onde ficarão os arquivos de sua aplicação [Front-End][FRONTBACKEND] (ex: `assets`, ou `public`). Considerando que seu projeto envolva uma parte [Back-End][FRONTBACKEND] e outra [Front-End][FRONTBACKEND], você terá uma pasta específica para o [Front-End][FRONTBACKEND], em outros casos pode ser a própria pasta rais do projeto.

## A pasta "components"

Aqui FICARÃO nossos componentes de interface.

## A pasta "controllers"

Aqui ficarão nossos controladores de páginas.

> **PS**: *Fica esquisito em português né? Mas são nossas controllers*.

## A pasta "utils"

Aqui ficarão nossos utilitários.

## O arquivo "index.html"

É o HTML de sua página.

> Aqui não tratamos de desenvolver aplicações [SPA][SPA] (como [Angular][ANGULAR], [AngularJS][ANGULARJS], [Ember][EMBER] ou [Vue.js][VUEJS]). Portanto, consideramos que cada página de sua aplicação utilizará a estrutura proposta.

## O arquivo "index.js"

O arquivo [JavaScript][JAVASCRIPT] de inicialização de sua aplicação. Mais à frente você verá que isso não é obrigatório, mas é sempre bom ter um ponto de inicialização, e se você precisar, esse será o recomendado.

> TODO: Terminar

<!-- Links -->
[JQUERY]: https://jquery.com "jQuery"
[TOAD]: https://github.com/e5r/jquery-toad "jQuery TOAD"
[MANUTENIBILIDADE]: https://pt.wikipedia.org/wiki/Manutenibilidade
[FRONTBACKEND]: https://pt.wikipedia.org/wiki/Front-end_e_back-end
[JAVASCRIPT]: https://developer.mozilla.org/pt-BR/docs/Web/JavaScript
[SPA]: https://pt.wikipedia.org/wiki/Aplicativo_de_p%C3%A1gina_%C3%BAnica
[ANGULAR]: https://angular.io
[ANGULARJS]: https://angularjs.org/
[EMBER]: https://www.emberjs.com/
[VUEJS]: https://vuejs.org/
